// ddopreload.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "ddopreload.h"


// Global Variables:
HINSTANCE hInst;								// current instance

static int curPhase = 0;
static const unsigned long cleanMemorySize=1280;


typedef unsigned char byte;


BOOL CALLBACK MainDlgProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam) {

	switch (msg) {
	case WM_INITDIALOG:
		SetClassLong(hDlg,GCL_HICON,(LONG_PTR)LoadImage(hInst,MAKEINTRESOURCE(IDI_DDOPRELOAD),IMAGE_ICON,0,0,LR_SHARED));
		break;
	case WM_COMMAND:
		if (LOWORD(wParam) == IDCANCEL) ExitProcess(0);
		break;
	}
	return FALSE;

}

BOOL CALLBACK ErrorDlgProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam) {

	switch (msg) {
	case WM_COMMAND:
		if (LOWORD(wParam) == IDCANCEL) ExitProcess(1);
		break;
	case WM_INITDIALOG:
		SetDlgItemText(hDlg,IDC_EDIT1,(const _TCHAR *)lParam);
	}
	return FALSE;

}

BOOL CALLBACK WarningDlgProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam) {

	switch (msg) {
	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK) EndDialog(hDlg,0);
		break;
	case WM_INITDIALOG:
		EnableWindow(GetDlgItem(hDlg,IDOK),TRUE);
		break;
	}
	return ErrorDlgProc(hDlg,msg,wParam,lParam);

}

void yeld() {
	MSG msg;
	while (PeekMessage(&msg,0,0,0,PM_REMOVE)) {
		DispatchMessage(&msg);
	}
}

void setPhase(HWND hDlg, int phase) {
	if (curPhase) {
		EnableWindow(GetDlgItem(hDlg,curPhase),FALSE);
		CheckDlgButton(hDlg,curPhase,BST_UNCHECKED);
	}
	curPhase = phase;
	if (curPhase) {
		EnableWindow(GetDlgItem(hDlg,curPhase),TRUE);
		CheckDlgButton(hDlg,curPhase,BST_CHECKED);
	}
	yeld();
}

void setProgress(HWND hDlg, int cur, int max) {
	HWND hProgess = GetDlgItem(hDlg,IDC_PROGRESS);
	SendMessage(hProgess,PBM_SETRANGE32,0,max);
	SendMessage(hProgess,PBM_SETPOS,cur,0);
	yeld();
}

void showError(HWND hDLg, const _TCHAR *msg) {
	DialogBoxParam(hInst,MAKEINTRESOURCE(IDD_ERROR),hDLg,&ErrorDlgProc,(LPARAM)msg);

}

void showWarning(HWND hDLg, const _TCHAR *msg) {
	DialogBoxParam(hInst,MAKEINTRESOURCE(IDD_ERROR),hDLg,&WarningDlgProc,(LPARAM)msg);

}

void checkMemory(HWND hDlg) {

	MEMORYSTATUSEX memSt;
	memSt.dwLength = sizeof(memSt);
	GlobalMemoryStatusEx(&memSt);
	if (memSt.ullTotalPhys/(1024*1024) < 1900) {
		showWarning(hDlg,_T("Not enough memory - preloader can be inefficient"));
	}
}


//#pragma optimize( "", off )
unsigned char __declspec(noinline) readMapFile( void * k, DWORD i ) 
{
	return *((unsigned char *)k+i);
}
//#pragma optimize( "", on )

void cleanupMemory(HWND hDlg) {
	setPhase(hDlg, IDC_PHASE1);
	HANDLE hmap = CreateFileMapping(0,0,PAGE_READWRITE,0,cleanMemorySize*1024*1024,0);
	void *ptrs[cleanMemorySize];
	ZeroMemory(ptrs,sizeof(ptrs));
	for (DWORD i = 0; i < cleanMemorySize; i++) {
		void *p = MapViewOfFile(hmap,FILE_MAP_ALL_ACCESS,0,1024*1024*i,1024*1024);
		if (p == 0) break;
		ptrs[i] = p;
		for (DWORD j = 0; j < 1024; j++) {
			*((unsigned char *)p+j*1024) = 1;			
		}
		setProgress(hDlg,cleanMemorySize-i,cleanMemorySize);
	}
	for (DWORD i = 0; i < cleanMemorySize; i++) {
		UnmapViewOfFile(ptrs[i]);
	}
	CloseHandle(hmap);
}


void preloadFile(HWND hDlg, _TCHAR *fname, bool ignoreError) {

	_TCHAR buff[1000];
	setPhase(hDlg, IDC_PHASE2);
	HANDLE h = CreateFile(fname,GENERIC_READ,FILE_SHARE_READ|FILE_SHARE_WRITE,0,OPEN_EXISTING,0,0);
	if (h == 0 || h == INVALID_HANDLE_VALUE) {
		_stprintf_s(buff,_T("Can't open file '%s'\n"),fname);
		if (!ignoreError) showError(hDlg,buff);
		return;
	}
	HANDLE hmap = CreateFileMapping(h,0,PAGE_READONLY ,0,0,0);
	CloseHandle(h);
	if (hmap == 0 || hmap == INVALID_HANDLE_VALUE)
	{
		_stprintf_s(buff,_T("Can't open mapping for file '%s'\n"),fname);
		if (!ignoreError) showError(hDlg,buff);
		return;
	}
	void *k = MapViewOfFile(hmap,FILE_MAP_READ ,0,0,0);
	if (k == 0) {
		_stprintf_s(buff,_T("Can't map file '%s'\n"),fname);
		if (!ignoreError) showError(hDlg,buff);
		CloseHandle(hmap);
		return;
	}

	MEMORY_BASIC_INFORMATION inf;
	VirtualQuery(k,&inf,sizeof(inf));

	byte b = 0;
	for (DWORD i = 0; i < inf.RegionSize; i+=4096) {
		b = b ^ readMapFile(k,i);
		if ((i & 0xFFFF) == 0)setProgress(hDlg,i/1024,inf.RegionSize/1024);
	}
	setProgress(hDlg,b,b);
	UnmapViewOfFile(k);
	CloseHandle(hmap);
}

VOID CALLBACK RefreshMapping(HWND hDlg, UINT msg, UINT_PTR even, DWORD tm) {
	preloadFile(hDlg,_T("client_gamelogic.dat"),true);
	setPhase(hDlg,IDC_PHASE3);
}

void launchGame(HWND hDlg) {
	STARTUPINFO nfo;
	ZeroMemory(&nfo,sizeof(nfo));
	PROCESS_INFORMATION pi;
	nfo.cb = sizeof(nfo);
	BOOL b = CreateProcess(_T("TurbineLauncher.exe"),_T("TurbineLauncher.exe -invoker"),0,0,0,0,0,0,&nfo,&pi);
	if (b == FALSE) {
		showError(hDlg,_T("Cannot start launcher"));
	}
	setPhase(hDlg,IDC_PHASE3);
	SetTimer(hDlg,1,10000,&RefreshMapping);
	while (FindWindow(0,_T("Dungeons and Dragons Online")) == 0 && WaitForSingleObject(pi.hProcess,0) == WAIT_TIMEOUT) {
		WaitMessage();
		yeld();
	}

}

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	InitCommonControls();
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

	hInst = hInstance;
	HWND hDlg = CreateDialog(hInst,MAKEINTRESOURCE(IDD_MAINDLG),0,&MainDlgProc);
	checkMemory(hDlg);
	cleanupMemory(hDlg);
	preloadFile(hDlg,_T("client_gamelogic.dat"),false);
	launchGame(hDlg);

	return 0;
}


